///home/berryj/link/bin/genMethods "-g" "-t" "Edge*" "-h" "Collection" "-I" "LINK/basic/SetFuncs.h" "-I" "LINK/basic/Collection.h" "-I" "LINK/graph/Edge.h" "-d" "graph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/SetFuncs.h>

#include <LINK/basic/Collection.h>

#include <LINK/graph/Edge.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>


typedef Edge* _Edge_;
typedef Collection<Edge* > _Collection_Edge__;

#define _Collection_Edge__DATA(x) ((Collection<Edge* >*) (EXTDATA(x)))
#define _Collection_Edge__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<Edge* > >::type))
#define _Collection_Edge__ISNT_DATA(x) (!_Collection_Edge__IS_DATA(x))

#define _Collection_Edge__CXX_DATA(x) (*(Collection<Edge* >*) (EXTDATA(VAL(x))))
#define _Collection_Edge__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<Edge* > >::type))
#define _Collection_Edge__CXX_ISNT_DATA(x) (!_Collection_Edge__CXX_IS_DATA(x))


PRIMITIVE STk_init__Collection_Edge__()
{
	Wrapper<_Collection_Edge__>::type = STk_new_CXXwrapper_id(
			Wrapper<_Collection_Edge__>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			CollectionWrapper<_Edge_>::displayTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Edge_>::markTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Edge_>::freeTypedCollection);
	Tcl_InitHashTable(&Register<_Collection_Edge__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_Collection_Edge__Methods(void);

PRIMITIVE STk_init_methods__Collection_Edge__()
{
	STk_add_new_cpp_primitive("collection-Edge?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::collectionP);
	STk_add_new_cpp_primitive("mset-Edge1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::buildMSet);
	STk_add_new_cpp_primitive("set-Edge1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::buildSet);
	STk_add_new_cpp_primitive("sequence-Edge1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::buildSequence);
	STk_add_new_cpp_primitive("Collection-Edge-sorted?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::sortedLinkCollection);
	STk_add_new_cpp_primitive("Collection-Edge-size", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::sizeLinkCollection);
	STk_add_new_cpp_primitive("Collection-Edge-null?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::nullLinkCollection);
	STk_add_new_cpp_primitive("Collection-Edge-eqv?", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::eqvLinkCollection);
	STk_add_new_cpp_primitive("Collection-Edge-<", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::lthLinkCollection);
	STk_add_new_cpp_primitive("Collection-Edge-<=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::leLinkCollection);
	STk_add_new_cpp_primitive("Collection-Edge->", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::grLinkCollection);
	STk_add_new_cpp_primitive("Collection-Edge->=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::geLinkCollection);
	STk_add_new_cpp_primitive("Collection-Edge-member", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::memberLinkCollection);
	STk_add_new_cpp_primitive("Collection-Edge-clear!", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::clearLinkCollection);
	STk_add_new_cpp_primitive("Collection-Edge-insert!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::insertLinkCollection);
	STk_add_new_cpp_primitive("Collection-Edge-append!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::appendLinkCollection);
	STk_add_new_cpp_primitive("Collection-Edge-remove!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::removeLinkCollection);
	STk_add_new_cpp_primitive("Collection-Edge-occurrences", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::occurrencesLinkCollection);
	STk_add_new_cpp_primitive("Collection-Edge-ref", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::refLinkCollection);
	STk_add_new_cpp_primitive("Collection-Edge-rank", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::rankLinkCollection);
	STk_add_new_cpp_primitive("Collection-Edge-+", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::unionLinkCollection);
	STk_add_new_cpp_primitive("Collection-Edge-^", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::intersectionLinkCollection);
	STk_add_new_cpp_primitive("Collection-Edge--", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::differenceLinkCollection);
	STk_add_new_cpp_primitive("Collection-Edge-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::subsetLinkCollection);
	STk_add_new_cpp_primitive("Collection-Edge-proper-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::properSubsetLinkCollection);
	STk_add_new_cpp_primitive("list->mset-Edge", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::stkList2LinkMSet);
	STk_add_new_cpp_primitive("list->set-Edge", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::stkList2LinkSet);
	STk_add_new_cpp_primitive("list->sequence-Edge", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::stkList2LinkSequence);
	STk_add_new_cpp_primitive("mset-Edge->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::collection2STkList);
	STk_add_new_cpp_primitive("set-Edge->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::collection2STkList);
	STk_add_new_cpp_primitive("sequence-Edge->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::collection2STkList);
	STk_add_new_cpp_primitive("mset-Edge->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::collection2STkString);
	STk_add_new_cpp_primitive("set-Edge->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::collection2STkString);
	STk_add_new_cpp_primitive("sequence-Edge->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Edge_>::collection2STkString);

	addListMethod("mset-Edge",
		"mset-Edge1", LINK_NEW);
	addListMethod("set-Edge",
		"set-Edge1", LINK_NEW);
	addListMethod("sequence-Edge",
		"sequence-Edge1", LINK_NEW);
	addOneArgMethod("null?",
		Wrapper<_Collection_Edge__ >::name, 
		"Collection-Edge-null?", LINK_OVL);
	addOneArgMethod("size",
		Wrapper<_Collection_Edge__ >::name, 
		"Collection-Edge-size", LINK_NEW);
	addTwoArgMethod("eqv?",
		Wrapper<_Collection_Edge__ >::name, 
		Wrapper<_Collection_Edge__ >::name, 
		"Collection-Edge-eqv?", LINK_OVL);
	addBooleanMethod("<",
		Wrapper<_Collection_Edge__ >::name, 
		"Collection-Edge-<", LINK_OVL);
	addBooleanMethod("<=",
		Wrapper<_Collection_Edge__ >::name, 
		"Collection-Edge-<=", LINK_OVL);
	addBooleanMethod(">",
		Wrapper<_Collection_Edge__ >::name, 
		"Collection-Edge->", LINK_OVL);
	addBooleanMethod(">=",
		Wrapper<_Collection_Edge__ >::name, 
		"Collection-Edge->=", LINK_OVL);
	addTwoArgMethod("member",
		Wrapper<_Edge_ >::name, 
		Wrapper<_Collection_Edge__ >::name, 
		"Collection-Edge-member", LINK_OVL);
	addTwoArgMethod("ref",
		Wrapper<_Collection_Edge__ >::name, 
		"<integer>",
		"Collection-Edge-ref", LINK_NEW);
	addOneArgMethod("clear!",
		Wrapper<_Collection_Edge__ >::name, 
		"Collection-Edge-clear!", LINK_NEW);
	addTwoArgMethod("insert!",
		Wrapper<_Edge_ >::name, 
		Wrapper<_Collection_Edge__ >::name, 
		"Collection-Edge-insert!", LINK_NEW);
	addTwoArgMethod("append!",
		Wrapper<_Edge_ >::name, 
		Wrapper<_Collection_Edge__ >::name, 
		"Collection-Edge-append!", LINK_NEW);
	addTwoArgMethod("remove!",
		Wrapper<_Edge_ >::name, 
		Wrapper<_Collection_Edge__ >::name, 
		"Collection-Edge-remove!", LINK_NEW);
	addArbMethod("+",
		Wrapper<_Collection_Edge__ >::name, 
		"Collection-Edge-+", LINK_OVL);
	addArbMethod("^",
		Wrapper<_Collection_Edge__ >::name, 
		"Collection-Edge-^", LINK_NEW);
	addArbMethod("-",
		Wrapper<_Collection_Edge__ >::name, 
		"Collection-Edge--", LINK_OVL);
	genExtra_Collection_Edge__Methods();
	return UNDEFINED;
}
